placingMode = false;
fullPositions = [];
function placeObject(x,y,type,rotation) {
  const type1 = document.createElement('div')
  type1.className = type;
  type1.style.transform = `rotate(${rotation}deg)`;
  type1.style.left = x + "px";
  type1.style.top = y + "px";
  type1.style.position = "absolute";
  document.getElementById("gsurface").appendChild(type1);
  plvwer.style.display = "none";
  placingMode = false;
  fullPositions.push({ x, y, type, rotation });
}


function isWithinGsurface(x, y) {
  const gsurface = document.getElementById("gsurface");
  const rect = gsurface.getBoundingClientRect();

  return (
    x >= rect.left &&
    x <= rect.right &&
    y >= rect.top &&
    y <= rect.bottom
  );
}

function checkCollision(x, y) {
  if (!isWithinGsurface(x, y)) {
    return false;
  }

  for (let i = 0; i < fullPositions.length; i++) {
    if (Math.abs(fullPositions[i].x - x) < 64 && Math.abs(fullPositions[i].y - y) < 64) {
      alert("Collision detected!");
      return false;
    }
  }
  return true;
}


function confirmPlacing() {
    var plvwer = document.getElementById("place-viewer");
    var x = parseInt(plvwer.style.left.replace("px", ""));
    var y = parseInt(plvwer.style.top.replace("px", ""));
    var type = plvwer.classList[0];
    var rotation = 0;
    if (checkCollision(x, y)) {
        placingMode = false;
        placeObject(x, y, type, rotation);
    document.getElementById("place-viewer").style.display = "none";
    
    }
    
}

function togglePlacingMode(item) {
    document.getElementById("place-viewer").style.display = "block";
    document.getElementById("place-viewer").classList = item; 
    placingMode = true;

}


document.addEventListener('mousemove', function(e) {
    if (placingMode == true) {
    var element = document.getElementById("gameframe");
    if (element.parentNode.querySelector(":hover") == element) {      var x = e.clientX
  var y = e.clientY

  var plvwer = document.getElementById("place-viewer")
  plvwer.style.left = (Math.round(x / 64) * 64) -96 + "px";
  plvwer.style.top  = (Math.round(y / 64) * 64) -96 + "px";}

}})

function stor2ndmenuToggle() {
    menu = document.getElementById("place-obj-store");
    if (menu.style.display == "none") {
        menu.style.display = "block";
    } else {  menu.style.display = "none";  }
}